Subject: Re: [ppsp] Peer-to-Peer Multimedia Answering Machine Technology

From: David Jonsson <[email-masked]>
Date: Thu, 13 Dec 2012 22:18:28 +0100

Hi all

I try to imagine how WebRTC and PPSP could be combined. The main issue is
that WebRTC is a browser builtin JavaScript lib which means that there is
no common networking and storage. Would PPSP have to be be run
over WebRTC DataChannel and SCTP? Should storage be done in RAM and/or with
file dialogs? Translate C++ code to JavaScript? Seems to require a lot of
development effort yes but the advantage to be able to run it straight away
in a browser might be worth it.

Another alternative is to use UDP or TCP sockets but that is only available
in JavaScript for Chrome Apps. Using Chrome Apps would also enable file
storage (without dialogs) .

Automatic translation from C++ to JavaScript could be done with llvm and
emscripten but some manual work has to be done with the event handling and
storage.

Making a PPSP browser plugin or separate application could be easier but I
imagine that fewer would install a browser plugin or a separate
application. The JavaScript alternative is I think also easier to maintain
and will also be usable on more platforms and browsers as WebRTC spreads.

Best wishes
David

On Thu, Dec 13, 2012 at 6:42 PM, Johan Pouwelse <[email-masked]> wrote:

> Dear Adam,
> Yes, WebRTC has many links and similarities to our PPSP work.
>
> I've been attending their IETF meetings and discussed in details with
> some of the browser creators what could be done.
> At this point the bottleneck is the usual I believe: development effort.
>
> We have now a mature PPSP-compliant streaming implementation
> which could be easily adapted for VOIP and WebRTC usage in
> scenarios you describe. https://github.com/triblerteam/libswift/
>
> You have time to turn your idea into a demo for next IETF?
>   -j
>
> On 13 December 2012 18:10, Adam Sobieski <[email-masked]> wrote:
> > Internet Engineering Task Force,
> > Peer-to-Peer Streaming Protocol Working Group,
> >
> > Greetings. WebRTC is a contemporary technology and pertains to video
> calls,
> > conferences, and potentially to video forums. WebRTC does include P2P
> > technologies and I would like to describe a scenario with regard to the
> P2P
> > distributed storage of hypertext, audio and video messages, with features
> > and functionality facilitating P2P multimedia answering machine
> technology.
> >
> > Scenario:
> >
> > Person A calls Person B. Person A might know whether Person B was online
> or
> > offline before they commenced a communication activity. If Person B is
> > online, the data motion is as per WebRTC. If Person B is offline, they
> could
> > have an answering machine multimedia clip available on a group of nodes
> > which they have designated, for example per a social network graph.
> >
> > Person A can watch Person B's streaming answering machine clip or skip to
> > leaving a message. If Person A leaves a message, that streaming video
> > message is stored on a group of nodes, possibly the union of the two
> groups
> > of nodes designated by both Person A and Person B. When Person B comes
> > online, within a system-specific duration of time, e.g. 90 days or 1
> year,
> > the portions of data are downloaded by them, segmented downloading, and
> > possibly with something like a BITS 4.0+ technology.
> >
> > If Person B chooses to view any of the streamable media during that
> initial
> > phase, which might not be uncommon, a log on and check messages pattern,
> the
> > segmented downloading can toggle to a streaming variety of download,
> > including variable bitrate streaming. Even after Person B might watch
> > real-time segmented downloads of variable-bitrate streaming multimedia,
> the
> > entirety of their high-bitrate messages could be downloaded and stored by
> > Person B unless or until Person B indicated otherwise.
> >
> >
> > Video calling and video conferencing have been illustrated with WebRTC
> > technologies, video forums may be realized upcoming, and we can envision,
> > research and develop features for P2P video communication systems, P2P
> > hypertext, audio and video systems, multimedia systems, including P2P
> > answering machine technologies as described.
> >
> >
> >
> > Kind regards,
> >
> > Adam Sobieski
> >
> > _______________________________________________
> > ppsp mailing list
> > [email-masked]
> > https://www.ietf.org/mailman/listinfo/ppsp
> >
> _______________________________________________
> ppsp mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/ppsp
>

---

From: Adam Sobieski <[email-masked]>
Date: Fri, 14 Dec 2012 05:24:30 +0000

PPSP Working Group,
David Jonsson,

Greetings. Thank you for the C++ and JavaScript topics, a useful JavaScript library idea is a distributed hash table library utilizing some of the new P2P capabilities in web browsers.  With DHT's, some of the storage topics also arise and, in addition to RAM, there is HTML5 web storage (http://www.w3.org/TR/webstorage/).  En route to a standard DHT JavaScript API, JavaScript DHT libraries can explore the API and implementational topics, as well as those of other reusable P2P components, in web browsers.

We can, as interesting, discuss architectures, designs, approaches to implementing P2P multimedia answering machine systems, while considering reusable and multifunctional components and technologies, some of which could be implemented as C++ or JavaScript libraries.

Kind regards,

Adam